package com.steerinfo.dil.service;

import java.math.BigDecimal;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleOrder服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsSaleOrder服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IAmsSaleOrderService {
    //查询所有未上报销售订单信息
    List<Map<String, Object>> getSaleOrderInfo(Map<String, Object> map);

    //查询所有已上报销售订单信息
    List<Map<String, Object>> getSaleOrderReported(Map<String, Object> map);

    //根据车序号查询销售订单详细
    List<Map<String, Object>> getSaleOrderDetail(Map<String, Object> map);

    //获取销售计划名称
    List<Map<String, Object>> getSalePlanName();

    //获取发货单位
    List<Map<String, Object>> getShipperName();

    //获取收货单位
    List<Map<String, Object>> getConsigneeCompanyName();

    //新增销售订单
    int addAmsSaleOrder(Map<String, Object> map) throws ParseException;

    //修改销售订单状态为已上报
    int uploadSaleOrder(BigDecimal saleOrderId) throws Exception;

    //获取要渲染的数据
    List<Map<String, Object>> selectBySaleOrderId(BigDecimal saleOrderId);

    //修改销售订单信息
    int updateAmsSaleOrder(Map<String,Object> map) throws ParseException;

    //通过主键删除销售订单及其从表使用信息
    int deleteAmsSaleOrderBySaleOrderId(BigDecimal saleOrderId);

    //查询所有财务已经审批的销售订单
    List<Map<String, Object>> getAmsSaleOrderApproved(Map<String, Object> map);

    //通过销售订单号查询销售订单的修改日志
    List<Map<String, Object>> getSaleOrderUpdateLog(Map<String, Object> map);


    //获取销售公司已审核的订单
    List<Map<String,Object>> getSaleOrderListBySaleCompany(Map<String,Object> map);

    //获得销售订单号
    List<Map<String, Object>> getSaleOrderList(Map<String, Object> mapValue);

    //获得承运商
    Map<String,Object> getCarrier(Integer addressId);



    //根据销售订单id查找基础信息，渲染数据
    Map<String, Object> selectInfoBySaleOrderId(BigDecimal saleOrderId);

    //根据销售订单id查找物资信息，渲染数据
    List<Map<String,Object>> selectMaterialInfoBySaleOrderId(BigDecimal saleOrderId);

    int addAmsDispatchSaleOrder(List<Map<String, Object>> mapValue);

    //查询未上报销售订单信息
    List<Map<String, Object>> getSaleOrderInfoes(Map<String, Object> map);

    //查询所有已上报销售订单信息
    List<Map<String, Object>> getSaleOrderReportedes(Map<String, Object> map);

    //获取销售公司已审核的订单
    List<Map<String,Object>> getSaleOrderListBySaleCompanyes(Map<String,Object> map);

    //查询所有财务已经审批的销售订单
    List<Map<String, Object>> getAmsSaleOrderApprovedes(Map<String, Object> map);

    List<Map<String, Object>> getSaleOrderAndMaterialById(Map<String,Object> mapValue);

    // 销售焦炭订单
    List<Map<String, Object>> getCokeSaleOrderList(Map<String,Object> mapValue);

    // 新增钢材销售订单
    int addSteelSaleOrder(Map<String, Object> mapValue) throws Exception;

    // 展示销售订单下的车序号和物资
    List<Map<String, Object>> getTruckNoAndMaterialList(BigDecimal saleOrderId);

    // 钢材派发运输订单
    int dispatchSteelOrder(List<Map<String, Object>> mapList) throws Exception;

    // 钢材继续装派单
    int continueSteelOrder(List<Map<String, Object>> mapList) throws Exception;

    // 根据详细地址id匹配承运商
    List<Map<String,Object>> getCarrierByPlace(BigDecimal placeId);

    // 根据详细地址匹配承运商
    Map<String, Object> getPriceByCarrierAndPlace(Map<String, Object> mapValue);

    // 将车序号下发给承运商
    int dispatchToCarrier(List<Map<String,Object>> mapList);

    List<Map<String,Object>> getSaleOrderListToCarrier(Map<String, Object> mapValue);
    //展示未匹配承运商的车序号
    List<Map<String, Object>> getSteelTruckNoList(Map<String, Object> mapValue);
    // 展示车序号的详情
    List<Map<String, Object>> getTruckNoMaterial(BigDecimal saleOrderMaterialId);
    // 展示已分配承运商但未派车的车序号
    List<Map<String, Object>> getNoCarTruckNoList(Map<String, Object> mapValue);
    // 展示已但未派车的车序号
    List<Map<String, Object>> getHaveCarTruckNoList(Map<String, Object> mapValue);
    //展示销售公司下发给承运商的销售订单列表
    List<Map<String, Object>> getSaleOrderListByCarrierSsoId(Map<String, Object> mapValue);
    // 删除销售订单
    int deleteSaleOrderById(BigDecimal saleOrderId);
    // 查询出销售订单的所有数据
    Map<String, Object> getAllSaleMessages(BigDecimal saleOrderId);
    // 修改承运商授权
    int updateTruckNoCarrier(Map<String, Object> mapValue);
    // 批量上传销售订单至金蝶
    int uploadSaleOrderList(List<Map<String, Object>> saleOrderIdList);
    // 新增钢材销售订单
    int addVanadiumSaleOrder(Map<String, Object> mapValue);
    // 自动匹配出最近的一个地址
    List<Map<String, Object>> matchingAddressRecently(BigDecimal receiveId);
    // 自动匹配上一条运单的司机电话
    String matchingDriverTelRecently(String capacityNumber);
    // 查询内转焦炭订单
    List<Map<String, Object>> getCokeInwardOrderList(Map<String, Object> mapValue);
    // 修改车辆收货地址
    int updateCarAddress(Map<String, Object> mapValue);
    // 修改销售订单中的物资
    int updateAllMaterialInSale(Map<String, Object> mapValue);
    //获取销售公司已审核的订单
    List<Map<String,Object>> getFuSaleOrderList(Map<String,Object> map);
    // 同步关闭金蝶销售订单
    int deleteSaleOrderSame(Map<String, Object> mapValue);
    // 展示反审批的钢材订单
    List<Map<String, Object>> getSteelOrderDeletedList(Map<String, Object> mapValue);
    // 展示所有状态销售订单列表
    List<Map<String, Object>> getAllSteelSaleOrderList(Map<String, Object> mapValue);
    // 修改厂内未装货车辆的运单车牌号
    Map<String, Object> updateCapacityNumberInFactory(Map<String, Object> mapValue) throws Exception;
    //修改收货客户的电话(销售)
    int updateConsigneeTel(Map<String,Object> mapValue);
    // 得到销售订单物资表主键
    List<Map<String, Object>> getSaleMaterialId(BigDecimal saleOrderMaterialId);
    // 查询下发给承运商的车序号信息
    List<Map<String, Object>> getCarrierTruckNoAndMaterialList(Map<String, Object> map);
    //设置销售订单分录物资中间表的deleted为1
    int updateAMSDeleted(BigDecimal closeWlEntryId);
    // 关闭单个钢材物资分录
    int closeSteelMaterialId(Map<String, Object> mapValue);
    // 展示已审核化产焦炭销售订单列表
    List<Map<String, Object>> getSaleCokeOrder(Map<String, Object> mapValue);
    // 反关闭金蝶单个分录
    int adverseCloseSaleMaterial(BigDecimal saleMaterialId);
    // 反关闭整个销售订单
    int adverseCloseSaleOrder(BigDecimal saleOrderId);

    List<Map<String, Object>> getKucunList(Map<String, Object> map);

    int reverseCloseOrder(Map<String, Object> map);

    int getSaleOrderStatus(String saleNumber);

    int adverseCloseSaleMaterialByEas(BigDecimal saleMaterialId);

    List<String> getEasPrimaryIds(Map<String, Object> map);

    int addSteelSaleOrderLoading(Map<String, Object> mapValue) throws Exception;

    BigDecimal selectTransPortOrder(BigDecimal closeWlEntryId);

    int updateTransportOrderStatus(BigDecimal orderId);
}